      .586
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

;     masm include files
      include \MASM32\INCLUDE\windows.inc
      include \MASM32\INCLUDE\masm32.inc
      include \MASM32\INCLUDE\gdi32.inc
      include \MASM32\INCLUDE\user32.inc
      include \MASM32\INCLUDE\kernel32.inc
      include \MASM32\INCLUDE\Comctl32.inc
      include \MASM32\INCLUDE\comdlg32.inc
      include \MASM32\INCLUDE\shell32.inc
      include \MASM32\INCLUDE\ole32.inc
      include \MASM32\INCLUDE\oleaut32.inc
      include \MASM32\INCLUDE\winmm.inc

;     masm libraries
      includelib \MASM32\LIB\masm32.lib
      includelib \MASM32\LIB\gdi32.lib
      includelib \MASM32\LIB\user32.lib
      includelib \MASM32\LIB\kernel32.lib
      includelib \MASM32\LIB\Comctl32.lib
      includelib \MASM32\LIB\comdlg32.lib
      includelib \MASM32\LIB\shell32.lib
      includelib \MASM32\LIB\ole32.lib
      includelib \MASM32\LIB\oleaut32.lib
      includelib \MASM32\LIB\winmm.lib

      include \MASM32\macros\macros.asm

;     local includes
      include ttsapi5.inc
      include ttsapi5.asm         ; the sapi 5 com interface

; #########################################################################
        ;=================
        ; Local prototypes
        ;=================
        SAPIdialogproc  PROTO :DWORD,:DWORD,:DWORD,:DWORD

        ID_BUTTON1 equ 1000
        ID_BUTTON2 equ 1001
        ID_EDIT1   equ 2000        
        ID_EDIT2   equ 3000        

    .data
         Textout        db 100 DUP (0)
         hInstance      dd 0

	 onceflag       dd 0

         Vdata          dd 256 DUP (0)      ; voice name
         number         db 50 DUP (0)
         Vnumber        dd 0                ; number of voices in computer
         Cvoice         dd 1                ; current voice number in use


         dlgname        db "SAPIdialog",0
         sapi_err       db "No Speech Application Programming Interface found!",0 

         szSAPI_CPL     db "\Program Files\Common Files\Microsoft Shared\Speech\sapi.cpl",0 ;

;         szSAPI_CPL     db "\Windows\System32\Speech\SpeechUX\sapi.cpl",0 ;Path for Vista

.data?
        icex INITCOMMONCONTROLSEX <> ;structure for Controls
    

; #########################################################################

.code

start:
      invoke GetModuleHandle, NULL
      mov hInstance, eax
      mov icex.dwSize,sizeof INITCOMMONCONTROLSEX
      mov icex.dwICC,0FFFFh
      invoke InitCommonControlsEx,ADDR icex

      invoke DialogBoxParam,hInstance,ADDR dlgname,0,ADDR SAPIdialogproc,0
      invoke ExitProcess,eax

; #########################################################################

SAPIdialogproc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

.if uMsg == WM_INITDIALOG
         invoke InitCom,hWin,1002      ; calls from sapi start at 1001
         cmp eax,0                     ; returns 0 = ok
         je @F
         invoke  MessageBox,0,ADDR sapi_err,0,MB_OK
      
         @@:

         invoke GetNumberOfVoicesCom
         mov Vnumber,eax
         mov eax,Cvoice
         .if eax > Vnumber || eax == 0                     ; check voice within range
         mov Cvoice,1
         .endif
         invoke SetAVoiceCom,eax                           ; get the voice
         invoke lstrcpy,addr Vdata,eax                     
         invoke SetDlgItemText,hWin,ID_EDIT2,ADDR Vdata

   
         invoke GetDlgItem,hWin,ID_EDIT1
         invoke SetFocus,eax
         mov onceflag,0 

.elseif uMsg == WM_COMMAND

       .if wParam == 1000  ; Speak button
          .if onceflag == 0
              invoke GetDlgItem,hWin,ID_EDIT1
              invoke SetFocus,eax           ; set focus
              invoke SendDlgItemMessage,hWin,ID_EDIT1,EM_SETSEL,0,0
              invoke GetDlgItemText,hWin,ID_EDIT1,ADDR Textout,100
              invoke SpeakCom,ADDR Textout,SPF_ASYNC
              mov onceflag,1 
          .endif

       .elseif wParam == 1001
               invoke ShellExecute,hWin,0,ADDR szSAPI_CPL,0,0,SW_SHOW 

       .elseif wParam == 1002                           ; SAPI callbacks 
              .if lParam == 1 || lParam == 3            ; SAPI stopped
                  invoke SendDlgItemMessage,hWin,ID_EDIT1,EM_SETSEL,0,0
                  invoke GetDlgItem,hWin,ID_EDIT1
                  invoke SetFocus,eax
                  mov onceflag,0
              .endif

       .elseif wParam == 1003
               push ebx
               mov eax,lParam                               ; hi lParam = character position
               shr eax,16
               mov ebx,lParam                               ; hi lParam = character position
               and ebx,0ffffh                               ; lo lParam = word length
               add ebx,eax
               invoke SendDlgItemMessage,hWin,ID_EDIT1,EM_SETSEL,eax,ebx
               pop ebx

       .elseif wParam == 1004

       .endif

.elseif uMsg == WM_CLOSE
        invoke EndDialog,hWin,NULL

.endif

    xor eax,eax
    ret

SAPIdialogproc endp

; #########################################################################

end start
