; -------------------------------------------------------------------------
; |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
;                                                                        ||
;                               ttsapi5.asm                              ||
;                                                                        ||
; For private use only                                                   ||
; |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
; -------------------------------------------------------------------------
;
; Full description in demo.zip at:
;
;            Dougie Murray  [http//:www.dougiem.fsnet.co.uk/asm]
;
;
;      .586                  
;      .model flat, stdcall   
;      option casemap :none   
;
; REQUIRED IMPORTS FOR TTSAPI5.ASM
;
;      include \MASM32\INCLUDE\windows.inc
;
;      include \MASM32\INCLUDE\masm32.inc
;      include \MASM32\INCLUDE\user32.inc
;      include \MASM32\INCLUDE\kernel32.inc
;      include \MASM32\INCLUDE\oleaut32.inc
;      include \MASM32\INCLUDE\ole32.inc
;
;     
;     
;      includelib \MASM32\LIB\masm32.lib
;      includelib \MASM32\LIB\user32.lib
;      includelib \MASM32\LIB\kernel32.lib
;      includelib \MASM32\LIB\oleaut32.lib
;      includelib \MASM32\LIB\ole32.lib
;
;|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
;=========================================================================
;|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||



;=========================================================================
;|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
;= since I only use 4 wave formats these are individually defined here ===
;== you may wish to use a calculation based on info below to set struc ===
.data

WAVEFORM1 struc       ; 11k - 8bit
    wFormatTag        dw WAVE_FORMAT_PCM    ; format type
    nChannels         dw 1                  ; number of channels (i.e. mono, stereo...)
    nSamplesPerSec    dd 11025              ; sample rate
    nAvgBytesPerSec   dd 11025   ; for buffer estimation  [sampls per sec]*[blk allign]
    nBlockAlign       dw 1       ; block size of data     ([ch]*[bits per smple])/8
    wBitsPerSample    dw 8                  ; Number of bits per sample of mono data 8or16
    cbSize            dw 0                  ; The count in bytes of the size of extra 
                                            ; information (after cbSize)
WAVEFORM1 ends
;-------------
WAVEFORM2 struc       ; 11k - 16bit
    wFormatTag        dw WAVE_FORMAT_PCM 
    nChannels         dw 1
    nSamplesPerSec    dd 11025
    nAvgBytesPerSec   dd 22050
    nBlockAlign       dw 2
    wBitsPerSample    dw 16 
    cbSize            dw 0 
WAVEFORM2 ends
;-------------
WAVEFORM3 struc       ; 22k - 16bit
    wFormatTag        dw WAVE_FORMAT_PCM 
    nChannels         dw 1
    nSamplesPerSec    dd 22050
    nAvgBytesPerSec   dd 44100
    nBlockAlign       dw 2
    wBitsPerSample    dw 16 
    cbSize            dw 0 
WAVEFORM3 ends
;-------------
WAVEFORM4 struc       ; 44k - 16bit 
    wFormatTag        dw WAVE_FORMAT_PCM 
    nChannels         dw 1
    nSamplesPerSec    dd 44100
    nAvgBytesPerSec   dd 88200
    nBlockAlign       dw 2
    wBitsPerSample    dw 16 
    cbSize            dw 0 
WAVEFORM4 ends

;====== only sentences defined in sapi 5.1 ===============================
SPDUI_SkipType               TEXTEQU <Sentence>

;====== converted to unicode =============================================
.data

    Voices                   UNICODE_TEXT
                             %LL SPCAT_VOICES
                             dw 00
    SkipType                 UNICODE_TEXT 
                             %LL SPDUI_SkipType
                             dw 00

; == Structures ==========================================================
    Status                        SPVOICESTATUS <>    ; in sapicom.inc
    Aud                           SPAUDIOSTATUS <>    ; in sapicom.inc
    Wav1                          WAVEFORM1 <>
    Wav2                          WAVEFORM2 <>
    Wav3                          WAVEFORM3 <>
    Wav4                          WAVEFORM4 <>

;== REFGUID ==============================================================
; from sapi.h SAPI 5.1 sdk
		 sSpeechAudioFormatGUIDWave    MGUID (C31ADBAE-527F-4ff5-A230-F62BB61FF70C)
		 sSpeechAudioFormatGUIDText    MGUID (7CEEF9F9-3D13-11d2-9EE7-00C04F797396)

		 SpeechAudioFormatGUIDWave     GUID sSpeechAudioFormatGUIDWave
		 SpeechAudioFormatGUIDText     GUID sSpeechAudioFormatGUIDText

; == Class IDs used here =================================================
    CLSID_SpVoice                 GUID sCLSID_SpVoice 
    CLSID_SpObjectTokenCategory   GUID sCLSID_SpObjectTokenCategory
    CLSID_SpObjectToken           GUID sCLSID_SpObjectToken 
    CLSID_SpStream                GUID sCLSID_SpStream

; == Iterface IDs used here ==============================================
    ISpVoice                      GUID sISpVoice
    ISpObjectTokenCategory        GUID sISpObjectTokenCategory
    ISpObjectToken                GUID sISpObjectToken
    ISpStream                     GUID sISpStream
    ISpStreamFormat               GUID sISpStreamFormat

; == pointer to pointers ================================================
    pVoice              dd 0      ; created objects
    pTokenCategory      dd 0
    pToken              dd 0
    pStream             dd 0
    pStreamFormat       dd 0

    pVoiceToken         dd 0      ; ptr to token in question
    pEnum               dd 0      ; enumeration obj
; ========================================================================
    pszTokenId          dd 0      ; voice token id string
    pszValue            dd 0      ; string name in token
    pCount              dd 0      ; No. of tokens in category

; == data ================================================================
    hWind               dd 0      ; main calling window handle
    wparam              dd 0      ; wParam sent to main window with WM_COMMAND
    StreamNumber        dd 0      ; speak input stream number
    WasSkipped          dd 0      ; number of sentences actually skipped
    RunState            dd 0      ; copy of states for change notify
    PosState            dd 0      ; 
	 BookState			dd 0		;
    VisemeState         dd 0      ;
    NULLbuffer          dd 0      ; empty buffer for stop
    playwaveF           dd 0      ; set on play/rec wave file
    wCount              dd 0      ; a counter for returning from StopWaveCom
    AnsiString          db 200 DUP (0) ; area for passing voice name in ANSI
;________________________________________________________________________
;||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

;                  SEE HELP FILE FOR DETAILS OF CALLS

;________________________________________________________________________
;||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

.code

SaveWaveCom proc  TextData:dword,FileName:dword,FileType:dword
; If the function fails, the return value is NON ZERO
LOCAL TempMem:DWORD
LOCAL count:dword
LOCAL param:dword
    .if FileType == 0 || FileType >8        ; test input request
         mov eax,1
    ret
    .endif
         mov playwaveF,1                    ; stream open flag
         mov wCount,0                       ; count for StopWaveCom
         invoke TextUni,FileName            ; text to unicode
         cmp eax,0
         je xout2                           ; on error
         mov TempMem,eax                    ; ptr to valid text

    .if FileType == 1                       ; select the correct format
         mov eax,offset Wav1                ; type from FileType
    .elseif FileType == 2
         mov eax,offset Wav2
    .elseif FileType == 3
         mov eax,offset Wav3
    .elseif FileType == 4
         mov eax,offset Wav4
    .elseif FileType >  4
         mov eax,offset Wav4
    .endif
    ; set the format to structure WAVEFORMATEX - and that it it is a wave file
    ; by specifying SpeechAudioFormatGUIDWave
ole32 pStream,ISpStream_BindToFile,TempMem,SPFM_CREATE_ALWAYS,\
              offset SpeechAudioFormatGUIDWave,eax,NULL,NULL
         cmp eax,0
         jne xout
    ; change the speech output to the file stream
ole32 pVoice,ISpVoice_SetOutput,pStream,FALSE
         cmp eax,0
         jne xout
    ; speak to file
invoke TextUni,TextData                     ; the data to unitext
ole32 pVoice,ISpVoice_Speak,eax,SPF_ASYNC,NULL
         push eax
         invoke SysFreeString,TextData      ; free memory
         invoke SysFreeString,TempMem       ; free memory
         pop eax
    ; [IspStream_Close, and _SetOutput default which is nessessary, 
    ; is done by repeat calling to StopWaveCom or a call to StopCom]
    ; this allows write async to enable main window

xout:
    ret
xout2:
         mov eax,1
    ret
SaveWaveCom endp

;=========================================================================
;|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
;=========================================================================
StopWaveCom proc             
;the return value is 0 = Stream Closed ok
;else wCount for every call
                             ; should be called repeatedly until eax = 0
                             ; allows the the record to be done SPF_ASYNC
         inc wCount                   
ole32 pVoice,ISpVoice_WaitUntilDone,0
         cmp eax,0           ; checks if wave is finished
         je @F               ; sapi turns off the _SetInterest callback
         mov eax,wCount      ; when output is to file, so I've used this method
    ret
    @@:
    ; close the stream
ole32 pStream,ISpStream_Close
    ; set the voice output back to default
ole32 pVoice,ISpVoice_SetOutput,NULL,FALSE

ret
StopWaveCom endp

;=========================================================================
;|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
;=========================================================================
PlayWaveCom proc nData:dword ; address of string - wavefilename.wav
;If the function fails, the return value is NON ZERO
LOCAL TempMem:dword

    .if playwaveF == 1                 ; allows use of async stream
ole32 pStream,ISpStream_Close          ; can be stopped externally
    .endif                             ; closes if re entered
         mov playwaveF,1               ; stream open flag

         invoke lstrlen,nData          ; start convert to unicode
         shl eax,1                     ; double string length
         push eax
         invoke SysAllocStringByteLen,0,eax ; allocate temp memory
         mov TempMem,eax
         pop eax                       ; text string to UNICODE
         invoke MultiByteToWideChar,CP_ACP,0,nData,-1,TempMem,eax ; ptr to string is TempMem

ole32 pStream,ISpStream_BindToFile,TempMem,SPFM_OPEN_READONLY,NULL,NULL,NULL,NULL
         cmp eax,0
         jne xout
ole32 pVoice,ISpVoice_SpeakStream,pStream,SPF_ASYNC, NULL
    ;  [ IspStream_Close, which is nessessary, is done on StopCom or re-entry ]
    xout:
         push eax
         invoke SysFreeString,TempMem   ; free memory
         pop eax
    ret
PlayWaveCom endp

;=========================================================================
;|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
;=========================================================================
GetNumberOfVoicesCom proc
;If the function fails, the return value is ZERO
;    returns eax == number of voices installed

         invoke GetVoicesCom,1
         cmp eax,0
         je xout
         mov eax,pCount
         xout:
    ret
GetNumberOfVoicesCom endp

;=========================================================================
;|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
;=========================================================================
SetAVoiceCom proc  nData
    ;    changes voice to voice number nData
    ;    returns eax == ptr to ascii string token name for nData voice
    ;    If the function fails, the return value is ZERO
         mov eax,nData
         invoke GetVoicesCom,eax
         cmp eax,0
         je xout
         push eax
    ;set a new voice token
ole32 pVoice,ISpVoice_SetVoice,pVoiceToken
         pop eax
    xout:
    ret
SetAVoiceCom endp

;=========================================================================
;|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
;=========================================================================
GetVoicesCom proc  nData:DWORD    ;not exported in dll version
     ;If the function fails, the return value is ZERO
    ;    returns always pCount == number of voices installed 
    ;    returns eax == 0 if nData < 1  or  > number of voices
    ;    else pVoiceToken == valid token for nData voice
    ;    and  eax == ptr to ascii string token name for nData voice

                   ; get sys default voice
ole32 pTokenCategory,ISpObjectTokenCategory_GetDefaultTokenId, offset pszTokenId
         cmp eax,0
         jne xout
                   ; Get token enum to all objecttokens
ole32 pTokenCategory,ISpObjectTokenCategory_EnumTokens,0,0,offset pEnum
         cmp eax,0
         jne xout
                   ; Get number of voices availlable
ole32 pEnum,IEnumSpObjectTokens_GetCount,offset pCount
         cmp eax,0
         jne xout

         mov eax,nData
         cmp eax,pCount     ; error check input request not higher
         mov eax,1
         ja xout

         mov eax,nData      ; error check input request not 0
         cmp eax,0
         mov eax,1
         je xout

@@:
                   ; get selected nData voice token
ole32 pEnum,IEnumSpObjectTokens_Next,1,offset pVoiceToken,NULL 
         dec nData ; do it nData times
         jne @B
                   ; get the string for that nData voice
ole32 pVoiceToken,ISpObjectToken_GetStringValue,NULL,offset pszValue
         cmp eax,0
         jne xout
                   ; get unicode to bytes in addr eax
         invoke UniText,pszValue
         push eax
         invoke CoTaskMemFree,pszValue
         pop eax
    ret
    xout:          ; returns eax,0 - error else eax,addr AsciiByteString 
         mov eax,0 ; of voice name
    ret
GetVoicesCom endp

;=========================================================================
;|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
;=========================================================================
;INITIALISE COM and VOICE
;   entry:Wind  = calling window handle.    
;         param = the wParam number used in callback
;         If the function fails, the return value is NON ZERO
InitCom proc Wind:dword,param:dword      

         push Wind                ;set main window handle
         pop hWind
         push param               ;and wParam for callback
         pop wparam
         invoke CoInitialize,0    ; load com libs
         or eax,eax               
         jnz xout
                                  ; create VOICE instance
         invoke CoCreateInstance,addr CLSID_SpVoice,NULL,CLSCTX_ALL,
                                 addr ISpVoice,addr pVoice
         or eax,eax
         jnz xout
                                  ; create STREAM instance
         invoke CoCreateInstance,addr CLSID_SpStream,NULL,CLSCTX_ALL,
                                 addr ISpStream,addr pStream
         or eax,eax
         jnz xout

         invoke CoCreateInstance,addr CLSID_SpStream,NULL,CLSCTX_ALL,
                                 addr ISpStreamFormat,addr pStreamFormat
         or eax,eax
         jnz xout

                                  ; create OBJECTTOKENCATEGORY instance
         invoke CoCreateInstance,addr CLSID_SpObjectTokenCategory,NULL,CLSCTX_ALL,
                                 addr ISpObjectTokenCategory,addr pTokenCategory
         or eax,eax
         jnz xout
                                  ; create OBJECTTOKEN
         invoke CoCreateInstance,addr CLSID_SpObjectToken,NULL,CLSCTX_ALL,
                                 addr ISpObjectToken,addr pToken
         or eax,eax
         jnz xout


         ; Get token from reg HKLMS\Speech\Voices to intialise voice cat.
         ole32 pTokenCategory,ISpObjectTokenCategory_SetId,offset Voices,FALSE

         cmp eax,0
         jne xout

    push edx                      ; set the required callbacks of interest
         mov edx,00000002h        ; codes running + wordboundary + viseme
									; 9/9/04: + bookmark
         mov eax,4000FFFEh        ; 40000027h              4000FFFEh = all
         ole32 pVoice,ISpVoice_SetInterest,Q64(eax,edx),Q64(eax,edx)
         ole32 pVoice,ISpVoice_SetNotifyCallbackFunction,offset pfnCallback,0,0
    pop edx
    xout:
    ret
InitCom endp

;=========================================================================
;|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
;=========================================================================
PauseCom proc
;If the function fails, the return value is NON ZERO
         ole32 pVoice,ISpVoice_Pause
ret
PauseCom endp

;=========================================================================
;|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
;=========================================================================
ResumeCom proc
;If the function fails, the return value is NON ZERO
         ole32 pVoice,ISpVoice_Resume
ret
ResumeCom endp


;=========================================================================
;|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
;=========================================================================
; entry:  TheText   = address of ascii zero text to speak
;         TextFlags = attributes flags SPF_ 
;If the function fails, the return value is NON ZERO
SpeakCom proc TheText:dword,TextFlags:dword
LOCAL TempMem:dword

         invoke TextUni,TheText
         mov TempMem,eax
ole32 pVoice,ISpVoice_Speak,eax,TextFlags,0 ;offset StreamNumber
         push eax
         invoke SysFreeString,TempMem       ; free memory
         pop eax
    ret
SpeakCom endp


;=========================================================================
;|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
;=========================================================================
StopCom proc                      ; sends a dword 0 with purge
;If the function fails, the return value is NON ZERO
         .if playwaveF == 1       ; if speaking wave file
          mov playwaveF,0         ; close stream
          ole32 pStream,ISpStream_Close
          ole32 pVoice,ISpVoice_SetOutput,NULL,FALSE
         .endif
         ole32 pVoice,ISpVoice_Speak,offset NULLbuffer,\
                                    SPF_PURGEBEFORESPEAK or SPF_ASYNC,0
ret 
StopCom endp

;=========================================================================
;|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
;=========================================================================
;             called internally from sapi
pfnCallback proc                  ; set at init time 
                                  ; checks the status of the voice output
                                  ; sends hwind,WM_COMMAND,wparam+x,state
push edx
				cmp wparam,0
				je xend

ole32 pVoice,ISpVoice_GetStatus,offset Status,NULL
         mov eax,Status.dwRunningState
         cmp eax, RunState        ; has the run state changed since last call?
         je @F
         mov RunState,eax         ; yes  -  send the state with WM_COMMAND,wParam,state
         invoke SendMessage,hWind,WM_COMMAND,wparam,eax ;ON OFF
         jmp xend

    @@:  mov eax,Status.lBookmarkId
				cmp eax,BookState
				je @F
				mov BookState,eax		; detect change
				cmp eax,0				; only from 0 to non 0
				je @F
				mov edx,wparam
				cmp edx,0
				je xend
				add edx,3
         invoke SendMessage,hWind,WM_COMMAND,edx,eax
				jmp xend

    @@:                           ; no   -  check word boundary
         mov eax,Status.ulInputWordPos
         cmp eax,PosState
         je @F
         mov edx,Status.ulInputWordLen
         mov PosState,eax         ; eax =
         shl eax,16               ; hi word eax = word position
         or eax,edx               ; lo word eax = word length
         mov edx,wparam           ; edx = wparam + 1 for calling main window
					cmp edx,0
					je xend
         inc edx
         invoke SendMessage,hWind,WM_COMMAND,edx,eax ;WORD BOUND
         jmp xend

    @@:
         mov eax,Status.VisemeId ; must be viseme
         mov edx,wparam           ; wParam + 2 for calling main window
         add edx,2
         invoke SendMessage,hWind,WM_COMMAND,edx,eax ;VISEME
   xend:
pop edx
    ret 8     ;this routine called from sapi requires stack adjust
pfnCallback endp

;=========================================================================
;|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
;=========================================================================
; returns with actual number skipped
SkipCom proc skip_Data:dword            ; skips nData sentences [-nData = backward]
                                  ; [only sentences supported (SkipType)]
ole32 pVoice,ISpVoice_Skip,offset SkipType,skip_Data,offset WasSkipped
cmp eax,0
jne xout
         mov eax,WasSkipped        
xout:        
    ret
SkipCom endp

;=========================================================================
;|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
;=========================================================================
SpeedCom proc nData:dword               ; rate of speech playback [nData -10 to 10]
;If the function fails, the return value is NON ZERO
ole32 pVoice,ISpVoice_SetRate,nData
    ret
SpeedCom endp

;=========================================================================
;|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
;=========================================================================

VolumeCom proc vol_Data:dword              ; percentage of maximum volume [nData 0 to 100]
;If the function fails, the return value is NON ZERO
ole32 pVoice,ISpVoice_SetVolume,vol_Data
    ret
VolumeCom endp

;=========================================================================
;|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
;=========================================================================
PollStatCom proc
; returns eax -      hi  byte = dwRunningState
;                        word = ulInputWordPos
;                        byte = ulInputWordLen
ole32 pVoice,ISpVoice_GetStatus,offset Status,NULL
cmp eax,0
jne xout
push edx
         mov eax,Status.dwRunningState
         shl eax,16
         mov edx,Status.ulInputWordPos
         or eax,edx
         shl eax,8
         mov edx,Status.ulInputWordLen
         or eax,edx
pop edx
ret
xout:
mov eax,0
ret
PollStatCom endp

;=========================================================================
;|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
;=========================================================================
;        converts unitext data at ptr uData to ANSI asciiz ptr eax
;        If the function fails, the return value is ZERO
UniText proc uData:dword
LOCAL TempMem:DWORD
;get length into eax
         invoke WideCharToMultiByte,CP_ACP,0,uData,-1,TempMem,0,NULL,NULL
         cmp eax,0
         je xout
         push eax
         mov eax,offset AnsiString ; allocate fixed memory
         mov TempMem,eax
         pop eax
         invoke WideCharToMultiByte,CP_ACP,0,uData,-1,TempMem,eax,NULL,NULL
         mov eax,TempMem
    xout:
    ret
UniText endp

;=========================================================================
;|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
;=========================================================================
;        converts ansi text data at ptr uData to unitext ptr eax
;If the function fails, the return value is ZERO
TextUni proc tData:dword
LOCAL TempMem:DWORD
;get length into eax
         invoke lstrlen,tData
         cmp eax,0
         je xout
         shl eax,1                          ; double string length
         push eax
         invoke SysAllocStringByteLen,0,eax ; allocate temp memory
         mov TempMem,eax
         pop eax                            ; text string to UNICODE
         invoke MultiByteToWideChar,CP_ACP,0,tData,-1,TempMem,eax 
         mov eax,TempMem
xout:
    ret
TextUni endp

;=========================================================================
;|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
;=========================================================================
EndCom proc
    OLE_FREE pToken
    OLE_FREE pTokenCategory
    OLE_FREE pStreamFormat
    OLE_FREE pStream
    OLE_FREE pVoice
    invoke CoUninitialize
ret
EndCom endp

;=========================================================================
;|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

